/*
 * Copyright 2023 University of Michigan EECS183
 *
 * AI.h
 * Project UID 28eb18c2c1ce490aada441e65559efdd
 *
 * Final Project - Elevators
 */

#ifndef _AI_H_
#define _AI_H_

#include <iostream>
#include "Utility.h"
#include "Move.h"
#include "BuildingState.h"
#include "Person.h"

//////////////////////////////////////////////////
/////// DO NOT MODIFY ANY CODE IN THIS FILE //////
/////////// ANY CONSTANTS/ETC SHOULD /////////////
////////////// BE ADDED IN THE .CPP //////////////
//////////////////////////////////////////////////

/*
* Requires: buildingState is a valid state representing the current building
* Modifies: Nothing
* Effects:  Returns a string that represents the decision the AI makes 
*           given the current state of the building, which it reads 
*           from buildingState.
*           The string should share the exact format as a 
*           human player's move input.
*/
string getAIMoveString(const BuildingState& buildingState);

/*
* Requires: buildingState is a valid state representing the current building
*           move is a pickup move that was generated by getAIMoveString()
*           floorToPickup represents the floor the pickup move occurred.
* Modifies: Nothing
* Effects:  Returns a string representing which people indices 
*           should be picked up. The string should share the exact format 
*           as a human player's pickup list input.
*/
string getAIPickupList(const Move& move, const BuildingState& buildingState, 
    const Floor& floorToPickup);

#endif
